package com.goafanti.common.dao;

import com.goafanti.admin.bo.AdminStatisticsBo;
import com.goafanti.admin.bo.CallDaysSumBo;
import com.goafanti.common.model.CallLog;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 呼叫记录(CallLog)表数据库访问层
 *
 * @author makejava
 * @since 2024-11-20 11:17:55
 */
public interface CallLogMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    CallLog queryById(Integer id);


    /**
     * 查询指定行数据
     *
     * @param callLog  查询条件
     * @return 对象列表
     */
    List<CallLog> findCallLogList(CallLog callLog);

    /**
     * 统计总行数
     *
     * @param callLog 查询条件
     * @return 总行数
     */
    int findCallLogCount(CallLog callLog);

    /**
     * 新增数据
     *
     * @param callLog 实例对象
     * @return 影响行数
     */
    int insert(CallLog callLog);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<CallLog> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<CallLog> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<CallLog> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<CallLog> entities);

    /**
     * 修改数据
     *
     * @param callLog 实例对象
     * @return 影响行数
     */
    int update(CallLog callLog);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    List<CallLog> selectByUid(String uid);


    AdminStatisticsBo selectAdminCallSum(@Param("aid") String aid, @Param("startTime") String startTime, @Param("endTime") String endTime);

    List<CallDaysSumBo> selectAllCount();
}

